---
title: SVG improvements in Firefox 3
slug: Mozilla/Firefox/Releases/3/SVG_improvements
tags:
  - Firefox 3
  - SVG
---
<div>{{FirefoxSidebar}}</div><div>{{ Fx_minversion_header(3) }}</div>
<p>Firefox 3 offers improved <a href="/en-US/docs/SVG">Scalable Vector Graphics</a> (SVG) support over prior versions of Firefox. While these features are documented elsewhere, this article serves as a convenient list so you can easily determine which features were added in Firefox 3.</p>
<ul>
  <li>The <code>foreignObject</code> element is now supported ({{ Bug(326966) }}). See the <a class="external" href="http://www.w3.org/TR/SVG11/extend.html#ForeignObjectElement">specification</a> or <a class="external" href="http://weblogs.mozillazine.org/roc/archives/2006/06/the_future_is_now.html">this article</a> for details.</li>
  <li><code>pattern</code> element support (<a class="external" href="http://www.w3.org/TR/SVG11/pservers.html#PatternElement">spec</a>)</li>
  <li><code>mask</code> element support (<a class="external" href="http://www.w3.org/TR/SVG11/masking.html#MaskElement">spec</a>)</li>
  <li>Support for all SVG 1.1 filters (<a class="external" href="http://www.w3.org/TR/SVG11/filters.html">spec</a>):
    <ul>
      <li><code>filter</code></li>
      <li><code>feDistantLight</code></li>
      <li><code>fePointLight</code></li>
      <li><code>feSpotLight</code></li>
      <li><code>feBlend</code></li>
      <li><code>feColorMatrix</code></li>
      <li><code>feConvolveMatrix</code></li>
      <li><code>feComponentTransfer</code>, <code>feFuncR</code>, <code>feFuncG</code>, <code>feFuncB</code>, <code>feFuncA</code></li>
      <li><code>feComposite</code></li>
      <li><code>feConvolveMatrix</code></li>
      <li><code>feDiffuseLighting</code></li>
      <li><code>feDisplacementMap</code></li>
      <li><code>feDistantLight</code></li>
      <li><code>feFlood</code></li>
      <li><code>feGaussianBlur</code></li>
      <li><code>feImage</code></li>
      <li><code>feMerge</code>, <code>feMergeNode</code></li>
      <li><code>feMorphology</code></li>
      <li><code>feOffset</code></li>
      <li><code>fePointLight</code></li>
      <li><code>feSpecularLighting</code></li>
      <li><code>feTurbulence</code></li>
      <li><code>feTile</code></li>
    </ul>
  </li>
  <li><code>&lt;a&gt;</code> element handling in SVG has had several bugs fixed; see {{ Bug(267664) }}, {{ Bug(268135) }}, {{ Bug(316248) }}, {{ Bug(317270) }} and {{ Bug(320724) }}.</li>
  <li>The SVG DOM Methods <code>getNumberOfChars()</code>, <code>getComputedTextLength()</code>, <code>getSubStringLength()</code>, <code>getStartPositionOfChar()</code>, <code>getEndPositionOfChar()</code>, <code>getRotationOfChar()</code>, and <code>getCharNumAtPosition()</code> have been implemented.</li>
  <li>the <code>xml:space</code> attribute support (<a class="external" href="http://www.w3.org/TR/SVG/text.html#WhiteSpace">spec</a>)</li>
  <li>fallback <code>fill</code>/<code>stroke</code> are now supported (<a class="external" href="http://www.w3.org/TR/SVG/painting.html#SpecifyingPaint">spec</a>)</li>
  <li><code>em</code> and <code>ex</code> units are now supported for indicating lengths ({{ Bug(305859) }}).</li>
</ul>

<h2 id="See_also">See also</h2>
<ul>
  <li><a href="/en-US/docs/SVG">SVG</a></li>
  <li><a href="/en-US/docs/SVG_in_Firefox">SVG in Firefox</a></li>
  <li><a href="/en-US/docs/Firefox_3_for_developers">Firefox 3 for developers</a></li>
</ul>
